var plugins_bb40132b_638b_4a9f_b028_d3fe47acc8d1 = 
{
    "init": function () {

	console.log("插件编写测试");

	// 可以写一些直接执行的代码
	// 在这里写的代码将会在【资源加载前】被执行，此时图片等资源尚未被加载。
	// 请勿在这里对包括bgm，图片等资源进行操作。


	this._afterLoadResources = function () {
		// 本函数将在所有资源加载完毕后，游戏开启前被执行
		// 可以在这个函数里面对资源进行一些操作，比如切分图片等。

		// 这是一个将assets.png拆分成若干个32x32像素的小图片并保存的样例。
		// var arr = core.splitImage("assets.png", 32, 32);
		// for (var i = 0; i < arr.length; i++) {
		//     core.material.images.images["asset"+i+".png"] = arr[i];
		// }

	}

	// 可以在任何地方（如afterXXX或自定义脚本事件）调用函数，方法为 core.plugin.xxx();
	// 从V2.6开始，插件中用this.XXX方式定义的函数也会被转发到core中，详见文档-脚本-函数的转发。
},
    "drawLight": function () {

	// 绘制灯光/漆黑层效果。调用方式 core.plugin.drawLight(...)
	// 【参数说明】
	// name：必填，要绘制到的画布名；可以是一个系统画布，或者是个自定义画布；如果不存在则创建
	// color：可选，只能是一个0~1之间的数，为不透明度的值。不填则默认为0.9。
	// lights：可选，一个数组，定义了每个独立的灯光。
	//        其中每一项是三元组 [x,y,r] x和y分别为该灯光的横纵坐标，r为该灯光的半径。
	// lightDec：可选，0到1之间，光从多少百分比才开始衰减（在此范围内保持全亮），不设置默认为0。
	//        比如lightDec为0.5代表，每个灯光部分内圈50%的范围全亮，50%以后才开始快速衰减。
	// 【调用样例】
	// core.plugin.drawLight('curtain'); // 在curtain层绘制全图不透明度0.9，等价于更改画面色调为[0,0,0,0.9]。
	// core.plugin.drawLight('ui', 0.95, [[25,11,46]]); // 在ui层绘制全图不透明度0.95，其中在(25,11)点存在一个半径为46的灯光效果。
	// core.plugin.drawLight('test', 0.2, [[25,11,46,0.1]]); // 创建一个test图层，不透明度0.2，其中在(25,11)点存在一个半径为46的灯光效果，灯光中心不透明度0.1。
	// core.plugin.drawLight('test2', 0.9, [[25,11,46],[105,121,88],[301,221,106]]); // 创建test2图层，且存在三个灯光效果，分别是中心(25,11)半径46，中心(105,121)半径88，中心(301,221)半径106。
	// core.plugin.drawLight('xxx', 0.3, [[25,11,46],[105,121,88,0.2]], 0.4); // 存在两个灯光效果，它们在内圈40%范围内保持全亮，且40%后才开始衰减。
	this.drawLight = function (name, color, lights, lightDec) {

		// 清空色调层；也可以修改成其它层比如animate/weather层，或者用自己创建的canvas
		var ctx = core.getContextByName(name);
		if (ctx == null) {
			if (typeof name == 'string')
				ctx = core.createCanvas(name, 0, 0, core.__PIXELS__, core.__PIXELS__, 98);
			else return;
		}

		ctx.mozImageSmoothingEnabled = false;
		ctx.webkitImageSmoothingEnabled = false;
		ctx.msImageSmoothingEnabled = false;
		ctx.imageSmoothingEnabled = false;

		core.clearMap(name);
		// 绘制色调层，默认不透明度
		if (color == null) color = 0.9;
		ctx.fillStyle = "rgba(0,0,0," + color + ")";
		ctx.fillRect(0, 0, ctx.canvas.width, ctx.canvas.height);

		lightDec = core.clamp(lightDec, 0, 1);

		// 绘制每个灯光效果
		ctx.globalCompositeOperation = 'destination-out';
		lights.forEach(function (light) {
			// 坐标，半径，中心不透明度
			var x = light[0],
				y = light[1],
				r = light[2];
			// 计算衰减距离
			var decDistance = parseInt(r * lightDec);
			// 正方形区域的直径和左上角坐标
			var grd = ctx.createRadialGradient(x, y, decDistance, x, y, r);
			grd.addColorStop(0, "rgba(0,0,0,1)");
			grd.addColorStop(1, "rgba(0,0,0,0)");
			ctx.beginPath();
			ctx.fillStyle = grd;
			ctx.arc(x, y, r, 0, 2 * Math.PI);
			ctx.fill();
		});
		ctx.globalCompositeOperation = 'source-over';
		// 可以在任何地方（如afterXXX或自定义脚本事件）调用函数，方法为  core.plugin.xxx();
	}
},
    "gravity": function () {
	// 在此增加新插件

	//下一点重力方向的X坐标
	this.nextGX = function (n) {
		if (n == null) n = 1;
		return core.getHeroLoc('x') + core.utils.scan[flags.gravityDirection].x * n;
	};

	//下一点重力方向的Y坐标
	this.nextGY = function (n) {
		if (n == null) n = 1;
		return core.getHeroLoc('y') + core.utils.scan[flags.gravityDirection].y * n;

	};

	//判断并触发重力
	//core.gravityActive();
	this.gravityActive = function () {
		var gravityDirection = flags.gravityDirection;
		var loc = core.status.hero.loc;
		var x = loc.x;
		var y = loc.y;
		var nx = core.nextGX();
		var ny = core.nextGY();
		if (core.isGravityMove(x, y, nx, ny)) {
			//core.lockControl();
			//console.log(1);
			//loc.direction = gravityDirection;
			flags.skiing = 1;
			core.insertAction('滑冰事件', null, null, null, true);
		} else {
			if (flags.todo) flags.todo();
			core.removeFlag('todo');
			//if (core.status.event.data && core.status.event.data.list) core.status.event.data.list[0].todo = [];
			flags.skiing = 0;
		}
	};

	this.isGravityMove = function (x, y, nx, ny) {
		var thisId = core.getBlockId(x, y);
		if (thisId == 'ladder') return false;
		if (thisId == 'flower') return false;
		if (nx < 0 || nx > core.bigmap.width - 1) return false;
		if (ny < 0 || ny > core.bigmap.height - 1) return false;
		var targetBlock = core.getBlock(nx, ny);
		var isEffect = core.isGravityEffect(targetBlock);

		var countHero = core.getFlag('countHero');
		for (var i = 0; i < countHero; i++) {
			if (core.getFlag('nowHero') == i) continue;
			if (core.getFlag('heroX' + i) == nx && core.getFlag('heroY' + i) == ny) isEffect = false;
		}
		return isEffect;
	};

	//判断一个block是否可以让勇士受重力影响而移动
	//core.isGravityEffect();
	this.isGravityEffect = function (targetBlock) {
		var targetId = 0;
		var targetCls = '';
		if (targetBlock) {
			targetId = targetBlock.block.id;
			targetCls = targetBlock.block.event.cls;
		} else {
			return true;
		}
		if (targetId == 0) return true;
		if (targetId == 168 || targetId == 'flower') return true;
		if (targetId == 2 || targetId == 'whiteWall') return true;
		if (targetCls == 'enemys' || targetCls == 'items') return true;
		return false;
	};

	//以下插件仅仅和本游戏有关
	//全局英雄列表
	//core.heroArray()
	this.heroArray = function () {
		return ['manHero', 'womanHero'];
	};

	//全局英雄图块数字列表
	//对应全局英雄列表的数字
	//core.heroArrayNumber()
	this.heroArrayNumber = function () {
		return [901, 902];
	};

	//全局英雄人物名字
	//对应全局英雄列表的名字
	//core.heroArrayName()
	this.heroArrayName = function () {
		return ['君浪', '秋橙'];
	};

	//开始游戏
	//core.startAdventure()
	this.startAdventure = function () {
		if (main.mode == 'editor') return;
		core.hideLadder();
		var countHero = core.status.thisMap.heroCount;
		flags.countHero = countHero; //本层英雄个数
		if (countHero <= 0) return;
		flags.nowHero = 0; //当前英雄
		for (var i = 0; i < countHero; i++) { //本游戏中只记录英雄2个状态，x位置，y位置
			if (core.isset(core.getHeroPosition(i))) {
				core.setFlag("heroX" + i, core.getHeroPosition(i).x);
				core.setFlag("heroY" + i, core.getHeroPosition(i).y);
			}
		}
		core.fgHero();
		core.showHero(0);
		core.status.hero.exp = 0;
		core.checkGetAllCoins();
	};

	//获得第n号英雄的位置
	//core.getHeroPosition(indexHero)
	this.getHeroPosition = function (indexHero) {
		var nowHero = flags.nowHero;
		if (nowHero == indexHero) {
			return core.status.hero.loc;
		} else {
			var blocks = core.summary(core.heroArray()[indexHero]);
			if (blocks.length == 1) {
				return blocks[0];
			}
		}
	};

	//重新刷新英雄
	//core.showHero(indexHero)
	this.showHero = function (indexHero) {
		var nowHero = flags.nowHero;
		var nowHeroX = core.status.hero.loc.x;
		var nowHeroY = core.status.hero.loc.y;

		var indexHeroX = core.getFlag('heroX' + indexHero);
		var indexHeroY = core.getFlag('heroY' + indexHero);

		core.setFlag('heroX' + nowHero, nowHeroX);
		core.setFlag('heroY' + nowHero, nowHeroY);

		core.setHeroLoc('x', indexHeroX);
		core.setHeroLoc('y', indexHeroY);
		core.setHeroLoc('direction', 'down');
		core.status.hero.name = core.heroArrayName()[indexHero];
		core.events.setHeroIcon('hero' + indexHero + '.png');
		core.clearMap('hero');
		core.drawHero();
		core.setBgFgBlock('fg', core.heroArrayNumber()[nowHero], nowHeroX, nowHeroY);
		core.setBgFgBlock('fg', 0, indexHeroX, indexHeroY);
		core.setFlag('nowHero', indexHero);
	};

	//切换英雄
	//core.changeHero();
	this.changeHero = function (noHint) {
		var nowHero = flags.nowHero;
		var countHero = flags.countHero;
		if (nowHero >= countHero - 1) core.showHero(0);
		else core.showHero(nowHero + 1);

		var targetX = -1;
		var targetY = -1;
		var x = core.status.hero.loc.x;
		var y = core.status.hero.loc.y;
		var b = true;
		var gravityDirection = flags.gravityDirection;
		if (gravityDirection == 'up') {
			if (y == height - 1) b = false;
			targetX = x;
			targetY = y + 1;
		} else if (gravityDirection == 'down') {
			if (y == 0) b = false;
			targetX = x;
			targetY = y - 1;
		} else if (gravityDirection == 'right') {
			if (x == 0) b = false;
			targetX = x - 1;
			targetY = y;
		} else if (gravityDirection == 'left') {
			if (x == width - 1) b = false;
			targetX = x + 1;
			targetY = y;
		}
		if (b && targetX >= 0 && targetY >= 0) {
			var id1 = 0;
			var id2 = 0;
			if (core.isset(core.getBlock(x, y))) id1 = core.getBlock(x, y).block.id;
			if (core.isset(core.getBlock(targetX, targetY))) id2 = core.getBlock(targetX, targetY).block.id;
			if (id1 == 903 || id2 == 903 || id2 == 168) {} else {
				for (var i = 0; i < countHero; i++) {
					if (core.getFlag('nowHero') == i) continue;
					if (core.getFlag('heroX' + i) == targetX && core.getFlag('heroY' + i) == targetY) {
						core.changeHero();
						return;
					}
				}
			}
		}
		if (!noHint) {
			core.insertAction([
				"\t[hero]\b[" + (core.status.hero.loc.y > 6 ? "up" : "down") + "," + core.status.hero.loc.x + "," + core.status.hero.loc.y + "]现在轮到我行动了！",
			], [
				{ "type": "function", "function": "function(){\ncore.showMapGroundNumber()\n}" },
			]);
			core.showMapGroundNumber();
		}
	};

	//隐藏梯子
	//core.hideLadder();
	this.hideLadder = function () {
		for (var i = core.status.thisMap.blocks.length - 1; i > 0; i--) {
			if (core.status.thisMap.blocks[i].event.id == 'ladderHidden')
				core.removeBlock(core.status.thisMap.blocks[i].x, core.status.thisMap.blocks[i].y);
		}
	};

	//显示梯子
	//core.showLadder();
	this.showLadder = function () {
		for (var i = 0; i < core.bigmap.height; i++) {
			for (var j = 0; j < core.bigmap.width; j++) {
				if (core.floors[core.status.floorId].map[i][j] == 904)
					core.setBlock(903, j, i);
			}
		}
	};

	//检查是否获得所有硬币
	//isBefore:是否在立马获得金币前调用
	//core.checkGetAllCoins();
	this.checkGetAllCoins = function (isBefore) {
		var moneyCount = core.searchBlock('coin', core.status.floorId).length;
		//if (isBefore) moneyCount--;
		core.status.hero.money = moneyCount;
		if (moneyCount <= 0) {
			core.showLadder();
		}
		core.updateStatusBar();
	};

	//统计当前地图某个id图块的所有位置
	//core.summary(id)
	this.summary = function (id) {
		var rtn = [];
		for (var i in core.status.thisMap.blocks) {
			if (core.status.thisMap.blocks[i].event.id == id)
				rtn.push({ 'x': core.status.thisMap.blocks[i].x, 'y': core.status.thisMap.blocks[i].y });
		}
		return rtn;
	};

	//将hero放到fg层
	this.fgHero = function () {
		for (var i in core.status.thisMap.blocks) {
			var index = core.heroArray().indexOf(core.status.thisMap.blocks[i].event.id);
			if (index >= 0) {
				core.setBgFgBlock('fg', core.heroArrayNumber()[index], core.status.thisMap.blocks[i].x, core.status.thisMap.blocks[i].y);
				core.removeBlock(core.status.thisMap.blocks[i].x, core.status.thisMap.blocks[i].y);
			}
		}
	};

	//修复墙体
	this.digRecover = function (passTime) {
		passTime = passTime || 1;
		for (var i = flags.dig.length - 1; i >= 0; i--) {
			if (flags.dig[i][2] <= passTime) {
				core.setBlock('yellowWall', flags.dig[i][0], flags.dig[i][1]);
				for (var j = 0; j < flags.countHero; j++) {
					if (core.getFlag('nowHero') == j) {
						if (core.status.hero.loc.x == flags.dig[i][0] && core.status.hero.loc.y == flags.dig[i][1]) {
							core.lose(core.heroArrayName()[j] + '被墙挤死了');
							return;
						}
					} else {
						if (core.getFlag('heroX' + j) == flags.dig[i][0] && core.getFlag('heroY' + j) == flags.dig[i][1]) {
							core.lose(core.heroArrayName()[j] + '被墙挤死了');
							return;
						}
					}
				}
				flags.dig.splice(i, 1);
			} else {
				flags.dig[i][2] -= passTime;
			}
		}
		core.showMapGroundNumber();
	};

	//显示点位数字
	this.showMapGroundNumber = function (isShow) {
		core.clearMap('event2');
		for (var i = flags.dig.length - 1; i >= 0; i--) {
			var x = flags.dig[i][0];
			var y = flags.dig[i][1];
			var z = flags.dig[i][2];
			core.fillText('event2', z, 8 + 32 * x, 20 + 32 * y, '#fff', '13px Arial');
		}
	};
},
    "rewrite": function () {
	// 在此增加新插件
	//重写移动事件，不能向反重力方向移动
	if (!core.maps._canMoveHero_checkPointOrigin) core.maps._canMoveHero_checkPointOrigin = core.maps._canMoveHero_checkPoint;
	core.maps._canMoveHero_checkPoint = function (x, y, direction, floorId, extraData) {
		if (core.maps._canMoveHero_checkPointOrigin(x, y, direction, floorId, extraData)) {

			if (!core.isset(x)) x = core.getHeroLoc('x');
			if (!core.isset(y)) y = core.getHeroLoc('y');
			if (!core.isset(direction)) direction = core.getHeroLoc('direction');
			floorId = floorId || core.status.floorId;
			if (!core.isset(floorId)) return false;
			var nx = x + core.utils.scan[direction].x,
				ny = y + core.utils.scan[direction].y;

			//检查是否向反重力方向移动
			var gravityDirection = core.getFlag("gravityDirection");
			if (gravityDirection == 'down' || gravityDirection == 'up' || gravityDirection == 'left' || gravityDirection == 'right') {
				var block = core.getBlock(x, y, floorId);
				var id = 0;
				if (core.isset(block)) id = block.block.id;

				var countHero = core.getFlag('countHero');
				for (var i = 0; i < countHero; i++) {
					if (core.getFlag('nowHero') == i) continue;
					if (core.getFlag('heroX' + i) == nx && core.getFlag('heroY' + i) == ny) return false;
				}

				if (id != 903) {
					if (gravityDirection == "down" && direction == "up") return false;
					if (gravityDirection == "up" && direction == "down") return false;
					if (gravityDirection == "left" && direction == "right") return false;
					if (gravityDirection == "right" && direction == "left") return false;
					//if (core.isGravityMove(x, y, core.nextGX(), core.nextGY()) && direction != gravityDirection) return false;
				}
			}
			return true;
		} else {
			return false;
		}
	};

	//重写passNet触发器
	if (!core.events.passNetOrigin) core.events.passNetOrigin = core.events.passNet;
	core.events.passNet = function (data) {
		if (data.event.id == 'princess') { // 公主
			if (core.summary('coin').length == 0) {
				core.win(core.status.thisMap.title);
			} else {
				core.insertAction([
					"\t[公主, princess]没有找到所有金币前，请不要找我！",
				]);
			}
			return;
		}
		if (data.event.id == 'whiteWall') { // 白墙
			core.gravityActive();
			return;
		}
		core.events.passNetOrigin(data);
	};

	//重写needDraw
	core.control._shouldDisplayStatus = function (id) {
		if (!core.isset(id)) {
			var toDraw = [],
				status = core.dom.status;
			for (var i = 0; i < status.length; ++i) {
				var dom = core.dom.status[i],
					idCol = dom.id;
				if (idCol.indexOf("Col") != idCol.length - 3) continue;
				var id = idCol.substring(0, idCol.length - 3);
				if (!core.control._shouldDisplayStatus(id)) continue;
				toDraw.push(id);
			}
			return toDraw;
		}
		switch (id) {
		case 'floor':
			return core.flags.enableFloor;
		case 'name':
			return core.flags.enableName;
		case 'lv':
			return core.flags.enableLv;
		case 'hpmax':
			return core.flags.enableHPMax;
		case 'atk':
			return false;
		case 'def':
			return false;
		case 'hp':
			return true;
		case 'mana':
			return core.flags.enableMana;
		case 'mdef':
			return core.flags.enableMDef;
		case 'money':
			return core.flags.enableMoney;
		case 'experience':
			return core.flags.enableExperience && !core.flags.levelUpLeftMode;
		case 'up':
			return core.flags.enableLevelUp;
		case 'skill':
			return core.flags.enableSkill;
		case 'key':
			return false;
		case 'pzf':
			return core.flags.enablePZF;
		case 'debuff':
			return core.flags.enableDebuff;
		default:
			return true;
		}
	};

	if (!core.control.setAutomaticRouteOrigin) core.control.setAutomaticRouteOrigin = core.control.setAutomaticRoute;
	core.control.setAutomaticRoute = function (destX, destY, stepPostfix) {
		var targetId = core.getBlockId(destX, destY);
		if (targetId == 'yellowWall') {
			var x = core.status.hero.loc.x;
			var y = core.status.hero.loc.y;
			if (x - 1 == destX && y + 1 == destY) {
				core.tryUseItem('leftAxe');
			} else if (x + 1 == destX && y + 1 == destY) {
				core.tryUseItem('rightAxe');
			}
		} else {
			core.control.setAutomaticRouteOrigin(destX, destY, stepPostfix);
		}
	};
}
}